#ifndef BUILD_H
#define BUILD_H

#include "Move.h"
#include "State.h"
#include <vector>

class BuildResult
{
public:
    int m_turns[2][2];
    bool m_usesZero[2];
    std::vector<Move> m_moves[2][2];
};

void getBuild(Value* pValue, BuildResult* pResult,
              int slotWithZero, int slotWithoutZero);

Value* _(Card card);
Value* _(int i);
Value* _(Value* pValue);

template<typename T>
Value* _1(ValueType vt, T arg1)
{
    Value* pResult = new Value();
    pResult->m_type = vt;
    pResult->m_arg1 = _(arg1);
    return pResult;
}

template<typename T1, typename T2>
Value* _2(ValueType vt, T1 arg1, T2 arg2)
{
    Value* pResult = new Value();
    pResult->m_type = vt;
    pResult->m_arg1 = _(arg1);
    pResult->m_arg2 = _(arg2);
    return pResult;
}
template<typename T>
Value* _S(T arg1) { return _1(VT_S_1, arg1); }
template<typename T1, typename T2>
Value* _S(T1 arg1, T2 arg2) { return _2(VT_S_2, arg1, arg2); }

template<typename T>
Value* _K(T arg1) { return _1(VT_K_1, arg1); }

template<typename T>
Value* _attack(T arg1) { return _1(VT_attack_1, arg1); }
template<typename T1, typename T2>
Value* _attack(T1 arg1, T2 arg2) { return _2(VT_attack_2, arg1, arg2); }

template<typename T>
Value* _help(T arg1) { return _1(VT_help_1, arg1); }
template<typename T1, typename T2>
Value* _help(T1 arg1, T2 arg2) { return _2(VT_help_2, arg1, arg2); }

template<typename T>
Value* _zombie(T arg1) { return _1(VT_zombie_1, arg1); }

#endif
