#ifndef MOVE_H
#define MOVE_H

#include <stdio.h>

enum Apply
{
    Left,
    Right
};

enum Card
{
    I,
    zero,
    succ,
    dbl,
    get,
    put,
    S,
    K,
    inc,
    dec,
    attack,
    help,
    copy,
    revive,
    zombie
};

class Move
{
    Move(Card, Card);
    Move(int, int);
public:
    Move()
        : m_apply(Left), m_card(I), m_slot(0) {}
    Move(Apply apply, Card card, int slot)
        : m_apply(apply), m_card(card), m_slot(slot) {}
    Move(Card card, int slot)
        : m_apply(Left), m_card(card), m_slot(slot) {}
    Move(int slot, Card card)
        : m_apply(Right), m_card(card), m_slot(slot) {}

    void dump(FILE* file) const;

    Apply m_apply;
    Card m_card;
    int m_slot;
};

#endif
