#include "Move.h"
#include "Program.h"
#include "Build.h"
#include <vector>

using std::vector;

struct ProgState
{
    enum Enum
    {
        Fence,
        FenceExec,
        Nop
    };
};

class Prog : public Program
{
public:
    Prog();
    ~Prog();

    virtual void proponent(Move* pMove);

    Value* m_pFenceValue;
    vector<Move> m_fenceMoves;

    ProgState::Enum m_ps;
    int m_idx;
};

Prog::Prog()
{
    m_pFenceValue =
        _S(
            _S(
                _S(
                    _S(help, succ),
                    _K(9216)
                    ),
                _S(_K(get), _K(1))
            ),
            _S(_K(succ), succ)
        )
        ;

    BuildResult buildResult;
    getBuild(m_pFenceValue, &buildResult, 1, 0);

    m_fenceMoves = buildResult.m_moves[true][true];

    m_fenceMoves.insert(
        m_fenceMoves.begin(),
        Move(put, 1));

#if 0
    m_pFenceValue->dump(stderr);
    fprintf(stderr, "\n");

    fprintf(stderr, "Build turns: %d without zero, %d with zero\n",
            buildResult.m_turns[true][false],
            buildResult.m_turns[true][true]);

    for (int i = 0; i < m_fenceMoves.size(); i++)
    {
        fprintf(stderr, "%d: ", i);
        m_fenceMoves[i].dump(stderr);
        fprintf(stderr, "\n");
    }
#endif

    m_ps = ProgState::Fence;
    m_idx = 0;
}

Prog::~Prog()
{
    m_pFenceValue->release();
}

void Prog::proponent(Move* pMove)
{
    if (m_ps == ProgState::Fence)
    {
        if (m_state.m_v[m_player][0] <= 0 ||
            m_state.m_v[m_player][1] <= 0)
        {
            m_ps = ProgState::Nop;
        }
    }

    if (m_ps == ProgState::FenceExec)
    {
        if (m_state.m_v[m_player][1] <= 0)
        {
            m_ps = ProgState::Nop;
        }
    }

    while (m_ps == ProgState::Fence &&
           m_fenceMoves[m_idx].m_apply == Left &&
           m_fenceMoves[m_idx].m_card == put &&
           m_state.m_f[m_player][m_fenceMoves[m_idx].m_slot]->m_type ==
           VT_I)
    {
        m_idx++;
        if (m_idx == m_fenceMoves.size())
        {
            m_ps = ProgState::FenceExec;
            m_idx = -1;
        }
    }

    if (m_ps == ProgState::Fence)
    {
            
        *pMove = m_fenceMoves[m_idx];
        m_idx++;
        if (m_idx == m_fenceMoves.size())
        {
            m_ps = ProgState::FenceExec;
            m_idx = -1;
        }
        return;
    }

    if (m_ps == ProgState::FenceExec)
    {
        *pMove = Move(1, zero);
        m_ps = ProgState::Nop;
        return;
    }

    int slot = 0;
    while (slot < 255 &&
           m_state.m_v[m_player][slot] <= 0)
    {
        slot++;
    }

    *pMove = Move(I, slot);
}

int main(int argc, char* argv[])
{
    Prog program;
    return program.run(argc, argv);
}
